
_Boot_Delay96k:

;boot18.c,18 :: 		void Boot_Delay96k()  org 97600
;boot18.c,21 :: 		MOVLW       20
	MOVLW       20
;boot18.c,22 :: 		MOVWF       R12, 0
	MOVWF       R12, 0
;boot18.c,23 :: 		MOVLW       121
	MOVLW       121
;boot18.c,24 :: 		MOVWF       R13, 0
	MOVWF       R13, 0
;boot18.c,25 :: 		Boot_Delay96k:
Boot_Delay96k:
;boot18.c,26 :: 		DECFSZ      R13, 1, 0
	DECFSZ      R13, 1, 0
;boot18.c,27 :: 		BRA         Boot_Delay96k
	BRA         Boot_Delay96k
;boot18.c,28 :: 		DECFSZ      R12, 1, 0
	DECFSZ      R12, 1, 0
;boot18.c,29 :: 		BRA         Boot_Delay96k
	BRA         Boot_Delay96k
;boot18.c,30 :: 		NOP
	NOP
;boot18.c,31 :: 		NOP
	NOP
;boot18.c,33 :: 		}
L_end_Boot_Delay96k:
	RETURN      0
; end of _Boot_Delay96k

_Susart_Init:

;boot18.c,36 :: 		void Susart_Init(unsigned short brg_reg) org 97952 { //65136 {
;boot18.c,39 :: 		RCSTA = 0x90;     //dactivation du port srie etActive la rception continue
	MOVLW       144
	MOVWF       RCSTA+0 
;boot18.c,40 :: 		TXSTA = 0x26;     // Registre de statut et de contrle dmission (USART)
	MOVLW       38
	MOVWF       TXSTA+0 
;boot18.c,41 :: 		TRISC.B7 = 1;
	BSF         TRISC+0, 7 
;boot18.c,42 :: 		TRISC.B6 = 0;
	BCF         TRISC+0, 6 
;boot18.c,44 :: 		while (PIR1.RCIF)   // Registre de signalisation dinterruptions de priphriques
L_Susart_Init1:
	BTFSS       PIR1+0, 5 
	GOTO        L_Susart_Init2
;boot18.c,45 :: 		i = RCREG;        // Registre de rception de lUSART
	GOTO        L_Susart_Init1
L_Susart_Init2:
;boot18.c,47 :: 		SPBRG = brg_reg;      // Registre du Gnrateur de Baud de lUSART
	MOVF        FARG_Susart_Init_brg_reg+0, 0 
	MOVWF       SPBRG+0 
;boot18.c,48 :: 		}
L_end_Susart_Init:
	RETURN      0
; end of _Susart_Init

_Susart_Write:

;boot18.c,51 :: 		void Susart_Write(unsigned short data_) org 97904 { //65080 {
;boot18.c,53 :: 		while (!TXSTA.TRMT)     // bit de statut du registre  dcalage dmission
L_Susart_Write3:
	BTFSC       TXSTA+0, 1 
	GOTO        L_Susart_Write4
;boot18.c,54 :: 		;
	GOTO        L_Susart_Write3
L_Susart_Write4:
;boot18.c,55 :: 		TXREG = data_;          // Registre de transmission de lUSART
	MOVF        FARG_Susart_Write_data_+0, 0 
	MOVWF       TXREG+0 
;boot18.c,56 :: 		}
L_end_Susart_Write:
	RETURN      0
; end of _Susart_Write

_Susart_Data_Ready:

;boot18.c,59 :: 		unsigned short Susart_Data_Ready() org 97938 { //65120 {
;boot18.c,60 :: 		return (PIR1.RCIF);       // Registre de signalisation dinterruptions de priphriques
	MOVLW       0
	BTFSC       PIR1+0, 5 
	MOVLW       1
	MOVWF       R0 
;boot18.c,61 :: 		}
L_end_Susart_Data_Ready:
	RETURN      0
; end of _Susart_Data_Ready

_Susart_Read:

;boot18.c,64 :: 		unsigned short Susart_Read() org 97868 { //65040 {
;boot18.c,66 :: 		rslt = RCREG;       // Registre de rception de lUSART
	MOVF        RCREG+0, 0 
	MOVWF       R1 
;boot18.c,68 :: 		if (RCSTA.OERR) {
	BTFSS       RCSTA+0, 1 
	GOTO        L_Susart_Read5
;boot18.c,71 :: 		RCSTA.CREN = 0;   // 1 = Active la rception continue
	BCF         RCSTA+0, 4 
;boot18.c,72 :: 		RCSTA.CREN = 1;   // 0 = Dsactive la rception continue
	BSF         RCSTA+0, 4 
;boot18.c,73 :: 		}
L_Susart_Read5:
;boot18.c,74 :: 		return rslt;
	MOVF        R1, 0 
	MOVWF       R0 
;boot18.c,75 :: 		}
L_end_Susart_Read:
	RETURN      0
; end of _Susart_Read

_Start_Program:

;boot18.c,82 :: 		void Start_Program() org 0x17FC0 { //0xFFC0 {
;boot18.c,84 :: 		}
L_end_Start_Program:
	RETURN      0
; end of _Start_Program

_Flash_Write_Sector:

;boot18.c,87 :: 		void Flash_Write_Sector(long address, char *sdata) org 97270 { //64020 {
;boot18.c,90 :: 		saveintcon = INTCON;
	MOVF        INTCON+0, 0 
	MOVWF       R1 
;boot18.c,93 :: 		TBLPTRL = Lo(address);
	MOVF        FARG_Flash_Write_Sector_address+0, 0 
	MOVWF       TBLPTRL 
;boot18.c,94 :: 		TBLPTRH = Hi(address);
	MOVF        FARG_Flash_Write_Sector_address+1, 0 
	MOVWF       TBLPTRH 
;boot18.c,95 :: 		TBLPTRU = Higher(address);
	MOVF        FARG_Flash_Write_Sector_address+2, 0 
	MOVWF       TBLPTRU 
;boot18.c,97 :: 		EECON1.EEPGD = 1;
	BSF         EECON1+0, 7 
;boot18.c,98 :: 		EECON1.CFGS = 0;
	BCF         EECON1+0, 6 
;boot18.c,99 :: 		EECON1.WREN = 1;
	BSF         EECON1+0, 2 
;boot18.c,100 :: 		EECON1.FREE = 1;
	BSF         EECON1+0, 4 
;boot18.c,101 :: 		INTCON.GIE = 0;
	BCF         INTCON+0, 7 
;boot18.c,102 :: 		EECON2 = 0x55;
	MOVLW       85
	MOVWF       EECON2+0 
;boot18.c,103 :: 		EECON2 = 0xAA;
	MOVLW       170
	MOVWF       EECON2+0 
;boot18.c,104 :: 		EECON1.WR = 1;
	BSF         EECON1+0, 1 
;boot18.c,105 :: 		INTCON.GIE = 1;
	BSF         INTCON+0, 7 
;boot18.c,106 :: 		asm TBLRD*- ;
	TBLRD*-
;boot18.c,108 :: 		FSR0L = Lo(sdata);
	MOVF        FARG_Flash_Write_Sector_sdata+0, 0 
	MOVWF       FSR0 
;boot18.c,109 :: 		FSR0H = Hi(sdata);
	MOVF        FARG_Flash_Write_Sector_sdata+1, 0 
	MOVWF       FSR0H 
;boot18.c,110 :: 		j = 0;
	CLRF        R3 
;boot18.c,111 :: 		while (j < _FLASH_ERASE/_FLASH_WRITE_LATCH) {
L_Flash_Write_Sector6:
	MOVLW       1
	SUBWF       R3, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Flash_Write_Sector7
;boot18.c,112 :: 		i = 0;
	CLRF        R2 
;boot18.c,113 :: 		while (i < _FLASH_WRITE_LATCH) {
L_Flash_Write_Sector8:
	MOVLW       64
	SUBWF       R2, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_Flash_Write_Sector9
;boot18.c,114 :: 		TABLAT  = POSTINC0;
	MOVF        POSTINC0+0, 0 
	MOVWF       TABLAT+0 
;boot18.c,116 :: 		TBLWT+*
	TBLWT+*
;boot18.c,118 :: 		i++;
	INCF        R2, 1 
;boot18.c,119 :: 		}
	GOTO        L_Flash_Write_Sector8
L_Flash_Write_Sector9:
;boot18.c,120 :: 		EECON1.EEPGD = 1;
	BSF         EECON1+0, 7 
;boot18.c,121 :: 		EECON1.CFGS = 0;
	BCF         EECON1+0, 6 
;boot18.c,122 :: 		EECON1.WREN = 1;
	BSF         EECON1+0, 2 
;boot18.c,123 :: 		INTCON.GIE = 0;
	BCF         INTCON+0, 7 
;boot18.c,124 :: 		EECON2 = 0x55;
	MOVLW       85
	MOVWF       EECON2+0 
;boot18.c,125 :: 		EECON2 = 0xAA;
	MOVLW       170
	MOVWF       EECON2+0 
;boot18.c,126 :: 		EECON1.WR = 1;
	BSF         EECON1+0, 1 
;boot18.c,127 :: 		j++;
	INCF        R3, 1 
;boot18.c,128 :: 		}
	GOTO        L_Flash_Write_Sector6
L_Flash_Write_Sector7:
;boot18.c,129 :: 		INTCON.GIE = 1;
	BSF         INTCON+0, 7 
;boot18.c,130 :: 		EECON1.WREN = 0;
	BCF         EECON1+0, 2 
;boot18.c,132 :: 		INTCON = saveintcon;
	MOVF        R1, 0 
	MOVWF       INTCON+0 
;boot18.c,133 :: 		}
L_end_Flash_Write_Sector:
	RETURN      0
; end of _Flash_Write_Sector

_Susart_Write_Loop:

;boot18.c,136 :: 		unsigned short Susart_Write_Loop(char send, char receive) org 97194 { //63926 {
;boot18.c,137 :: 		unsigned short rslt = 0;
	CLRF        Susart_Write_Loop_rslt_L0+0 
;boot18.c,139 :: 		LBL_BOOT18_96:
___Susart_Write_Loop_LBL_BOOT18_96:
;boot18.c,140 :: 		Boot_Delay96k();
	CALL        _Boot_Delay96k+0, 0
;boot18.c,141 :: 		Susart_Write(send);
	MOVF        FARG_Susart_Write_Loop_send+0, 0 
	MOVWF       FARG_Susart_Write_data_+0 
	CALL        _Susart_Write+0, 0
;boot18.c,142 :: 		Boot_Delay96k();
	CALL        _Boot_Delay96k+0, 0
;boot18.c,144 :: 		rslt++;
	INCF        Susart_Write_Loop_rslt_L0+0, 1 
;boot18.c,145 :: 		if (rslt == 255u)
	MOVF        Susart_Write_Loop_rslt_L0+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_Susart_Write_Loop10
;boot18.c,146 :: 		return 0;
	CLRF        R0 
	GOTO        L_end_Susart_Write_Loop
L_Susart_Write_Loop10:
;boot18.c,147 :: 		if (Susart_Read() == receive)
	CALL        _Susart_Read+0, 0
	MOVF        R0, 0 
	XORWF       FARG_Susart_Write_Loop_receive+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Susart_Write_Loop11
;boot18.c,148 :: 		return 1;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_Susart_Write_Loop
L_Susart_Write_Loop11:
;boot18.c,149 :: 		goto LBL_BOOT18_96;
	GOTO        ___Susart_Write_Loop_LBL_BOOT18_96
;boot18.c,150 :: 		}
L_end_Susart_Write_Loop:
	RETURN      0
; end of _Susart_Write_Loop

_Write_Begin:

;boot18.c,157 :: 		void Write_Begin() org 97708 { //64774 {
;boot18.c,159 :: 		Flash_Write_Sector(0x17FC0, block);   //0xFFC0, block);
	MOVLW       192
	MOVWF       FARG_Flash_Write_Sector_address+0 
	MOVLW       127
	MOVWF       FARG_Flash_Write_Sector_address+1 
	MOVLW       1
	MOVWF       FARG_Flash_Write_Sector_address+2 
	MOVLW       0
	MOVWF       FARG_Flash_Write_Sector_address+3 
	MOVLW       boot18_block+0
	MOVWF       FARG_Flash_Write_Sector_sdata+0 
	MOVLW       hi_addr(boot18_block+0)
	MOVWF       FARG_Flash_Write_Sector_sdata+1 
	CALL        _Flash_Write_Sector+0, 0
;boot18.c,161 :: 		block[0] = 0xBC;
	MOVLW       188
	MOVWF       boot18_block+0 
;boot18.c,162 :: 		block[1] = 0xEF;
	MOVLW       239
	MOVWF       boot18_block+1 
;boot18.c,163 :: 		block[2] = 0xBE;//7E;
	MOVLW       190
	MOVWF       boot18_block+2 
;boot18.c,164 :: 		block[3] = 0xF0;
	MOVLW       240
	MOVWF       boot18_block+3 
;boot18.c,166 :: 		}
L_end_Write_Begin:
	RETURN      0
; end of _Write_Begin

_Start_Bootload:

;boot18.c,170 :: 		void Start_Bootload() org 97996 { //65186 {
;boot18.c,171 :: 		unsigned short i = 0, xx, yy;
	CLRF        Start_Bootload_i_L0+0 
	CLRF        Start_Bootload_j_L0+0 
	CLRF        Start_Bootload_j_L0+1 
	CLRF        Start_Bootload_j_L0+2 
	CLRF        Start_Bootload_j_L0+3 
;boot18.c,174 :: 		while (1) {
L_Start_Bootload12:
;boot18.c,175 :: 		if (i == 64u) {
	MOVF        Start_Bootload_i_L0+0, 0 
	XORLW       64
	BTFSS       STATUS+0, 2 
	GOTO        L_Start_Bootload14
;boot18.c,177 :: 		if (!j)
	MOVF        Start_Bootload_j_L0+0, 0 
	IORWF       Start_Bootload_j_L0+1, 0 
	IORWF       Start_Bootload_j_L0+2, 0 
	IORWF       Start_Bootload_j_L0+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_Start_Bootload15
;boot18.c,178 :: 		Write_Begin();
	CALL        _Write_Begin+0, 0
L_Start_Bootload15:
;boot18.c,179 :: 		Flash_Write_Sector(j, block);
	MOVF        Start_Bootload_j_L0+0, 0 
	MOVWF       FARG_Flash_Write_Sector_address+0 
	MOVF        Start_Bootload_j_L0+1, 0 
	MOVWF       FARG_Flash_Write_Sector_address+1 
	MOVF        Start_Bootload_j_L0+2, 0 
	MOVWF       FARG_Flash_Write_Sector_address+2 
	MOVF        Start_Bootload_j_L0+3, 0 
	MOVWF       FARG_Flash_Write_Sector_address+3 
	MOVLW       boot18_block+0
	MOVWF       FARG_Flash_Write_Sector_sdata+0 
	MOVLW       hi_addr(boot18_block+0)
	MOVWF       FARG_Flash_Write_Sector_sdata+1 
	CALL        _Flash_Write_Sector+0, 0
;boot18.c,181 :: 		i = 0;
	CLRF        Start_Bootload_i_L0+0 
;boot18.c,182 :: 		j += 0x40;
	MOVLW       64
	ADDWF       Start_Bootload_j_L0+0, 1 
	MOVLW       0
	ADDWFC      Start_Bootload_j_L0+1, 1 
	ADDWFC      Start_Bootload_j_L0+2, 1 
	ADDWFC      Start_Bootload_j_L0+3, 1 
;boot18.c,183 :: 		}
L_Start_Bootload14:
;boot18.c,185 :: 		Susart_Write('y');
	MOVLW       121
	MOVWF       FARG_Susart_Write_data_+0 
	CALL        _Susart_Write+0, 0
;boot18.c,186 :: 		while (!Susart_Data_Ready()) ;
L_Start_Bootload16:
	CALL        _Susart_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_Start_Bootload17
	GOTO        L_Start_Bootload16
L_Start_Bootload17:
;boot18.c,188 :: 		yy = Susart_Read();
	CALL        _Susart_Read+0, 0
	MOVF        R0, 0 
	MOVWF       Start_Bootload_yy_L0+0 
;boot18.c,190 :: 		Susart_Write('x');
	MOVLW       120
	MOVWF       FARG_Susart_Write_data_+0 
	CALL        _Susart_Write+0, 0
;boot18.c,191 :: 		while (!Susart_Data_Ready()) ;
L_Start_Bootload18:
	CALL        _Susart_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_Start_Bootload19
	GOTO        L_Start_Bootload18
L_Start_Bootload19:
;boot18.c,193 :: 		xx = Susart_Read();
	CALL        _Susart_Read+0, 0
	MOVF        R0, 0 
	MOVWF       Start_Bootload_xx_L0+0 
;boot18.c,195 :: 		block[i++] = yy;
	MOVLW       boot18_block+0
	MOVWF       FSR1 
	MOVLW       hi_addr(boot18_block+0)
	MOVWF       FSR1H 
	MOVF        Start_Bootload_i_L0+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        Start_Bootload_yy_L0+0, 0 
	MOVWF       POSTINC1+0 
	INCF        Start_Bootload_i_L0+0, 1 
;boot18.c,196 :: 		block[i++] = xx;
	MOVLW       boot18_block+0
	MOVWF       FSR1 
	MOVLW       hi_addr(boot18_block+0)
	MOVWF       FSR1H 
	MOVF        Start_Bootload_i_L0+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        Start_Bootload_xx_L0+0, 0 
	MOVWF       POSTINC1+0 
	INCF        Start_Bootload_i_L0+0, 1 
;boot18.c,197 :: 		}
	GOTO        L_Start_Bootload12
;boot18.c,198 :: 		}
L_end_Start_Bootload:
	RETURN      0
; end of _Start_Bootload
